function basis = extendBasisBlur(imgSrcClear, rectObjClear, basis, szTemplate, paramBlur)

%imgSrcClear: the clear image that will be blurred. We can assume the 1st image is a clear one. (Gray image, not normalized)
%rectObjClear: the rectangle of object in the clear image.(x, y, w, h) Using this rectangle to crop the image patch from the blurred clear image.

ltPoint = [rectObjClear(1), rectObjClear(2)];%(x y)
rbPoint = [ltPoint(1) + rectObjClear(3) - 1, ltPoint(2) + rectObjClear(4) - 1];

angles = 180/paramBlur.numAngle*(1:paramBlur.numAngle);
motions = paramBlur.startLength:paramBlur.intervalLength:paramBlur.endLength;

blurTmpltSet = zeros(prod(szTemplate), length(angles)*length(motions));
n=1;
for i=1:length(angles)
    for j=1:length(motions)
        
        kernel = fspecial('motion', motions(j), angles(i));

        imgBlur = imfilter(imgSrcClear, kernel, 'replicate');
        
        imgPatchSet(:,:,n) = imgBlur(ltPoint(2):rbPoint(2), ltPoint(1):rbPoint(1));
        blurTemplate = imresize(imgPatchSet(:,:,n), szTemplate);
        
        blurTmpltSet(:,n) = reshape(blurTemplate, prod(szTemplate), 1);
        
        MN = size(blurTmpltSet(:,n),1);
        a = mean(blurTmpltSet(:,n));
        b = std(blurTmpltSet(:,n));
        blurTmpltSet(:,n) = (blurTmpltSet(:,n) - ones(MN,1)*a) ./ (ones(MN,1)*b);
        blurTmpltSet(:,n) = blurTmpltSet(:,n)/norm(blurTmpltSet(:,n));        
        
        n = n+1;
    end
end

basis = [basis blurTmpltSet];
