function samples = initBasisL1(img, objRect, numBasis, szBasis)

sampleNum = numBasis;
%% prepare templates geometric parameters
if numBasis == 10
r{1} = objRect;
r{2} = objRect + [-1;-1;0;0];
r{3} = objRect + [-1;0;0;0];
r{4} = objRect + [-1;1;0;0];
r{5} = objRect + [0;-1;0;0];
r{6} = objRect + [0;1;0;0];
r{7} = objRect + [1;-1;0;0];
r{8} = objRect + [1;0;0;0];
r{9} = objRect + [1;1;0;0];
r{10} = objRect + [2;0;0;0];
elseif numBasis == 1
    r{1} = objRect;
end
%% Initializating templates and image
samples	= zeros(prod(szBasis), sampleNum);

%% cropping and normalizing templates
for n=1:sampleNum
    rect = r{n};
    imgPatch = img(rect(2):rect(2)+rect(4)-1, rect(1):rect(1)+rect(3)-1);
    imgPatch = imresize(imgPatch, szBasis);
    samples(:,n) =  imgPatch(:);
    
    %normalization using L2 norm
    MN = size(samples(:,n),1);
    a = mean(samples(:,n));
    b = std(samples(:,n));
    samples(:,n) = (samples(:,n) - ones(MN,1)*a) ./ (ones(MN,1)*b);
    samples(:,n) = samples(:,n)/norm(samples(:,n));  
end


