function [paraD paraT] = paramConfig(paraD,paraT)


%% data parameter

switch paraD.name
    case 'owl'
        paraD.folder =  '..\data\owl\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext	= 'jpg'; %image format
        paraD.numStart	= 0; %start frame number
%         paraD.numEnd = 630; %end frame number
        paraD.numEnd = 99; %shorter for demo
        paraD.szImg = [640 480];%(width height)

        paraT.objRect = [352;197;56;100];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [20 12];
        
    case 'body'
        paraD.folder =  '..\data\body\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 150; %start frame number
        paraD.numEnd = 483;%611; %end frame number
        paraD.szImg = [640 480];%(width height)

        paraT.objRect = [401;47;85;317];
        paraT.szBasis = [20 10];
        
    case 'face'
        paraD.folder =  '..\data\face\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 0; %start frame number
        paraD.numEnd = 492; %end frame number
        paraD.szImg = [640 480];%(width height)

        paraT.objRect = [246;226;94;114];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [17 15];

    case 'car1'
        paraD.folder =  '..\data\car1\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 247; %start frame number
        paraD.numEnd = 988; %end frame number
        paraD.szImg = [640 480];%(width height)
        
        paraT.objRect = [250;167;106;106];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [16 16];

    case 'car2'
        paraD.folder =  '..\data\car2\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 3; %start frame number
        paraD.numEnd = 587; %end frame number
        paraD.szImg = [640 480];%(width height)

        paraT.objRect = [231;209;116;98];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [ 16 16];

    case 'car3'
        paraD.folder =  '..\data\car3\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 3; %start frame number
        paraD.numEnd = 475; %end frame number
        paraD.szImg = [640 480];%(width height)
        
        paraT.objRect = [229;234;80;66];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [16 16];
        
    case 'car4'
        paraD.folder =  '..\data\car4\';%folder storing the images
        paraD.numZ	= 4;	%number of digits for the frame index
        paraD.ext		= 'jpg'; %image format
        paraD.numStart	= 18; %start frame number
        paraD.numEnd = 397; %end frame number
        paraD.szImg = [640 480];%(width height)
        
        paraT.objRect = [199;203;162;150];%the initial object rectangle in the first frame: (x y w h)
        paraT.szBasis = [16 16];
        
    otherwise
        fprintf('error! The sequence name does not exist');
end

paraD.length = paraD.numEnd - paraD.numStart + 1;

%% tracking parameter

paraT.wPost = 1;%postprocessing the weight according to the distance to the estimated object center.
paraT.dis_div = 5;

paraT.ratio_num_clear_reserve = 0.1;
paraT.ratio_num_motion = 0.1;
paraT.xyDiv_motion = 20;
paraT.motion_threshold = 10;
paraT.chlImg = 1;%gray image or color image is needed for the tracking approach

%parameter for particle filter
paraT.numPtcl = 500;
paraT.numState = 3;
paraT.xyDiv = 20;%for state propogation
paraT.sDiv = 0.02;%for state propogation

%parameter for nmf
paraT.solver = 'SpaRSA';% SPAMS, SpaRSA
paraT.numBasis = 10;

%parameter for blur templates
paraT.paramBlur.numAngle = 8;
paraT.paramBlur.startLength = 10;
paraT.paramBlur.endLength  = 80;
paraT.paramBlur.intervalLength = 10;
paraT.paramBlur.numBlurBasis = paraT.paramBlur.numAngle*length(paraT.paramBlur.startLength:paraT.paramBlur.intervalLength:paraT.paramBlur.endLength);

%0:no trivial;1:only positive;2:positive+negtive
paraT.typeTrivial = 2;

%0: gaussian function; 
%1: exp function.
paraT.likelihoodType = 'gauss';

%for likelihood
paraT.lamda = -500;
paraT.var = 1e-4;



