function tracker = prepare(seq, paraT, ptclSet)

%tracker parameter setup
tracker.status = true;
tracker.name = paraT.name;

%target parameter setup
objRect = paraT.objRect;
target.objRect = objRect;
target.center = round([objRect(1)+objRect(3)/2; objRect(2)+objRect(4)/2]);
target.rectHistory = [];
target.centerHistory = [];

tracker.particle = [];
tracker.target = [];
tracker.model = [];

%particle parameter setup

particle.likelihoodType = paraT.likelihoodType;
particle.var = paraT.var;

particle.centerHistory = [];

pcNum = paraT.numPtcl;

particle.num = paraT.numPtcl;
particle.dim = paraT.numState;
particle.weight = ones(pcNum, 1)/pcNum;
particle.status = logical(ones(pcNum, 1));
particle.state = ones(particle.dim, pcNum);
particle.state(1:2,:) = repmat(target.center, [1 pcNum]);
particle.rect=repmat(target.objRect, [1 pcNum]);
particle.xyDiv = paraT.xyDiv;
particle.sDiv = paraT.sDiv;

particle.lamda = paraT.lamda;
particle.coefHistory = [];%the reconstruction coefficient history of the target patch using L1 optimization, including blur template coefficient components.
particle.rectHistory = [];%for debug easier.

particle.ratio_num_clear_reserve = paraT.ratio_num_clear_reserve;
particle.ratio_num_motion = paraT.ratio_num_motion;
particle.xyDiv_motion = paraT.xyDiv_motion;
particle.motion_threshold = paraT.motion_threshold;

particle.interval = [];
particle.indexBlurAngle = [];
particle.numPtclBlurAngle=[];

particle.paramBlur=paraT.paramBlur;
particle.wPost = paraT.wPost;
particle.dis_div = paraT.dis_div;

particle.solver = paraT.solver;
particle.szBasis = paraT.szBasis;
particle.numBasis = paraT.numBasis;

switch particle.solver
    case  'pos' 
        particle.trivialBasis = calcTrivialBasis(paraT.szBasis, paraT.typeTrivial);%[eye(dim_T) -eye(dim_T)]; %data matrix is composed of T, positive and negative trivial T.
    otherwise
        particle.trivialBasis= calcTrivialBasis(paraT.szBasis, 1);%eye(dim_T); %data matrix is composed of T, positive trivial T.
end

particle = propogatePtcl(particle, seq.szImg, ptclSet,1);%1: initialization

tracker.particle = particle;
tracker.target = target;

%initialize the basis set for sparse coding
tracker.model = calcModel(seq, paraT);





