function  particle = propogatePtcl(particle, szImg, ptclSet, bInit)

particle.status = logical(ones(particle.num, 1));

if bInit
    xyDiv = 0.2;
    sDiv = 0;
else
    xyDiv = particle.xyDiv;
    sDiv = particle.sDiv;
end

pcNum = particle.num;

if particle.dim == 2
    particle.state = particle.state + xyDiv*ptclSet(1:2, 1:pcNum);
    particle.rect(1,:) = round(particle.state(1,:)-particle.rect(3,:)/2);
    particle.rect(2,:) = round(particle.state(2,:)-particle.rect(4,:)/2);
elseif particle.dim == 3
    particle.state(1:2, :) = particle.state(1:2, :) + xyDiv*ptclSet(1:2, 1:pcNum);
    
    particle.state(3, :) = 1 + sDiv*ptclSet(3, 1:pcNum);
    
    particle.rect(3,:) = round(particle.state(3, :) .* particle.rect(3,:));
    particle.rect(4,:) = round(particle.state(3, :) .* particle.rect(4,:));
    particle.rect(1,:) = round(particle.state(1,:)-particle.rect(3,:)/2);
    particle.rect(2,:) = round(particle.state(2,:)-particle.rect(4,:)/2);
end
particle.rectHistory = [particle.rectHistory;particle.rect];

% Check if the particles are dead or not
for i = 1:pcNum
    pcRect = particle.rect(:, i);
    
    if pcRect(1)<1||pcRect(2)<1||pcRect(1)+pcRect(3)>szImg(1)||pcRect(2)+pcRect(4)>szImg(2)
        particle.status(i)=0;
    end
end
