function  particle = propogatePtcl_blut(particle, centerHistory, szImg, ptclSet, rand_index)


particle.status = logical(ones(particle.num, 1));
paramBlur = particle.paramBlur;
numAngle=paramBlur.numAngle;
motions = paramBlur.startLength:paramBlur.intervalLength:paramBlur.endLength;
numStrength = length(motions);

numBasis = particle.numBasis;

xyDiv = particle.xyDiv;
sDiv = particle.sDiv;

ratio_num_clear_reserve = particle.ratio_num_clear_reserve;
ratio_num_motion = particle.ratio_num_motion;
xyDiv_motion = particle.xyDiv_motion;

num_clear_reserve = round(particle.num*ratio_num_clear_reserve);
num_motion = round(particle.num*ratio_num_motion);

pcNum = particle.num - num_clear_reserve - num_motion;

particle.state = particle.state(:,rand_index(1:particle.num));
particle.rect = particle.rect(:,rand_index(1:particle.num));


particle.num_cluster=1;
particle.num_ptcl_clear = particle.num;
particle.interval=[];

if particle.dim == 2
    particle.state = particle.state + xyDiv*ptclSet(1:2, 1:particle.num);
    particle.rect(1,:) = round(particle.state(1,:)-particle.rect(3,:)/2);
    particle.rect(2,:) = round(particle.state(2,:)-particle.rect(4,:)/2);
elseif particle.dim == 3
    if (size(centerHistory,2)>1)
        v = centerHistory(:,end) - centerHistory(:,end-1);
        v_p = [v(1) -v(2)];%coordination transform

        if norm(v)> particle.motion_threshold
            
            a=atan(v_p(2)/v_p(1));

            if v_p(1)<0
                a = a+pi;
            end
            if a < 0
                a=a+2*pi;
            end
            if a==0
                a=2*pi;
            end

            coef=particle.coefHistory(:,end);
            
            angles = pi/paramBlur.numAngle*(1:paramBlur.numAngle);
            
            coef_clear = coef(1:numBasis);
            coef_blur_angle = reshape(coef(numBasis+1:end), [ numStrength numAngle ]);%each column corresponding to one angle
            sum_blur_angle = sum(coef_blur_angle);
            sum_clear = sum(coef_clear);
            sum_total = sum([sum_clear sum_blur_angle]);
            sum_blur_normalized = sum_blur_angle/sum_total;
            sum_clear_normalized = sum_clear/sum_total;
 
            num_ptcl_blur_angle = round(pcNum*sum_blur_normalized);
            num_cluster = 1+sum(num_ptcl_blur_angle>0);
            num_blur_total = sum(num_ptcl_blur_angle);
            num_ptcl_clear = particle.num - num_blur_total;%including the reserved
            
            blur_index = find(num_ptcl_blur_angle>0);
            num_blur = num_ptcl_blur_angle(find(num_ptcl_blur_angle>0));         
            
            particle.num_cluster=[];
            particle.num_ptcl_clear = [];
            
            particle.indexBlurAngle = [];
            particle.numPtclBlurAngle = [];
            
            
            if ~isempty(blur_index)&&~isempty(num_blur)
                
                particle.num_cluster=num_cluster;
                particle.num_ptcl_clear = num_ptcl_clear;
            
                particle.indexBlurAngle = blur_index;
                particle.numPtclBlurAngle = num_blur;


                interval(2,:) = num_blur;
                
                for i =2:length(num_blur)
                    interval(1,i) = interval(2,i-1)+1;
                    interval(2,i) = interval(2,i) + interval(1,i) - 1;
                end
                interval(1,1) = 1;
                particle.interval = interval;
                for i =1:length(blur_index)
                    j = blur_index(i);
                    angle = angles(j);
                    num = num_ptcl_blur_angle(j);
                    motion_length=motions*(coef_blur_angle(:,j)/sum_blur_angle(j));

                    if abs(angle-a)> pi/2 && abs(angle-a) < 1.5*pi
                        angle = angle+pi;
                    end
                    
                    motion = motion_length*[cos(angle) sin(angle)];
                    motion(2) = -motion(2);%%transform back to image coordination
                    
                    rotationM = [cos(angle) -sin(angle);sin(angle) cos(angle)];
                    xDiv = norm(motion)/2;
                    yDiv = xDiv/2;
                    pSet = rotationM'*[xDiv*ptclSet(1,interval(1,i):interval(2,i)); yDiv*ptclSet(2,interval(1,i):interval(2,i))];
                    particle.state(1, interval(1,i):interval(2,i)) = particle.state(1, interval(1,i):interval(2,i)) + motion(1) + pSet(1,:);
                    particle.state(2, interval(1,i):interval(2,i)) = particle.state(2, interval(1,i):interval(2,i)) + motion(2) + pSet(2,:);
                end
                particle.state(1:2,num_blur_total+1:num_blur_total+num_motion) = particle.state(1:2, num_blur_total+1:num_blur_total+num_motion) + repmat(v,[1,num_motion]) + xyDiv_motion*ptclSet(1:2, num_blur_total+1:num_blur_total+num_motion);
                
                particle.state(1:2, num_blur_total+num_motion+1:end) = particle.state(1:2, num_blur_total+num_motion+1:end) + xyDiv*ptclSet(1:2, num_blur_total+num_motion+1:particle.num);
                
            else
                particle.state(1:2, 1:num_motion) = particle.state(1:2, 1:num_motion) + repmat(v,[1,num_motion]) + xyDiv_motion*ptclSet(1:2, 1:num_motion);
                particle.state(1:2, num_motion+1:end) = particle.state(1:2, num_motion+1:end) + xyDiv*ptclSet(1:2, num_motion+1:end);
            end
        else
            particle.state(1:2, :) = particle.state(1:2, :) + xyDiv*ptclSet(1:2, 1:particle.num);
        end
    else
        particle.state(1:2, :) = particle.state(1:2, :) + xyDiv*ptclSet(1:2, 1:particle.num);
    end
    particle.state(3, :) = 1 + sDiv*ptclSet(3, 1:particle.num);
    
    particle.rect(3,:) = round(particle.state(3, :) .* particle.rect(3,:));
    particle.rect(4,:) = round(particle.state(3, :) .* particle.rect(4,:));
    particle.rect(1,:) = round(particle.state(1,:)-particle.rect(3,:)/2);
    particle.rect(2,:) = round(particle.state(2,:)-particle.rect(4,:)/2);
end

particle.rectHistory = [particle.rectHistory;particle.rect];

% Check if the particles are dead or not
for i = 1:particle.num
    pcRect = particle.rect(:, i);    
    if pcRect(1)<1||pcRect(2)<1||pcRect(1)+pcRect(3)>szImg(1)||pcRect(2)+pcRect(4)>szImg(2)
        particle.status(i)=0;
    end
end
